Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6406)
@@ -22,24 +22,16 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
+using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
+using HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-using HeuristicLab.Optimization;
-using HeuristicLab.Common;
-using System.Drawing;
-using HeuristicLab.Data;
-using System.IO;
-using HeuristicLab.Problems.Scheduling.Evaluators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Problems.Scheduling.Analyzers;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Encodings.SchedulingEncoding;
-using HeuristicLab.Encodings.SchedulingEncoding.Interfaces;
-using HeuristicLab.Encodings.SchedulingEncoding.JobSequenceMatrix;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Encodings.SchedulingEncoding.PriorityRulesVector;
-using HeuristicLab.Encodings.SchedulingEncoding.PermutationWithRepetition;
-using HeuristicLab.Problems.Scheduling.Decoders;
 
 namespace HeuristicLab.Problems.Scheduling {
@@ -48,81 +40,74 @@
   [StorableClass]
   public sealed class JobShopSchedulingProblem : SchedulingProblem {
+    #region Parameter Properties
+    public ValueParameter<ItemList<Job>> JobDataParameter {
+      get { return (ValueParameter<ItemList<Job>>)Parameters["JobData"]; }
+    }
+    public OptionalValueParameter<Schedule> BestKnownSolutionParameter {
+      get { return (OptionalValueParameter<Schedule>)Parameters["BestKnownSolution"]; }
+    }
+
+    public ValueParameter<IntValue> JobsParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Jobs"]; }
+    }
+    public ValueParameter<IntValue> ResourcesParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Resources"]; }
+    }
+    public ValueParameter<SchedulingEvaluator> SolutionEvaluatorParameter {
+      get { return (ValueParameter<SchedulingEvaluator>)Parameters["SolutionEvaluator"]; }
+    }
+    public ValueParameter<BoolValue> DueDatesParameter {
+      get { return (ValueParameter<BoolValue>)Parameters["DueDates"]; }
+    }
+    #endregion
+
+    #region Properties
+    public ItemList<Job> JobData {
+      get { return JobDataParameter.Value; }
+      set { JobDataParameter.Value = value; }
+    }
+    public Schedule BestKnownSolution {
+      get { return BestKnownSolutionParameter.Value; }
+      set { BestKnownSolutionParameter.Value = value; }
+    }
+    public IntValue Jobs {
+      get { return JobsParameter.Value; }
+      set { JobsParameter.Value = value; }
+    }
+    public IntValue Resources {
+      get { return ResourcesParameter.Value; }
+      set { ResourcesParameter.Value = value; }
+    }
+    public SchedulingEvaluator SolutionEvaluator {
+      get { return SolutionEvaluatorParameter.Value; }
+      set { SolutionEvaluatorParameter.Value = value; }
+    }
+    public BoolValue DueDates {
+      get { return DueDatesParameter.Value; }
+      set { DueDatesParameter.Value = value; }
+    }
+    #endregion
+
+    public JobShopSchedulingProblem()
+      : base(new SchedulingEvaluationAlgorithm(), new JSMRandomCreator()) {
+      Parameters.Add(new ValueParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<Job>()));
+      Parameters.Add(new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance."));
+
+      Parameters.Add(new ValueParameter<IntValue>("Jobs", "The number of jobs used in this JSSP instance.", new IntValue()));
+      Parameters.Add(new ValueParameter<IntValue>("Resources", "The number of resources used this JSSP instance.", new IntValue()));
+      Parameters.Add(new ValueParameter<BoolValue>("DueDates", "Determines whether the problem instance uses due dates or not.", new BoolValue()));
+      Parameters.Add(new ValueParameter<SchedulingEvaluator>("SolutionEvaluator", "The evaluator used to determine the quality of a solution.", new MakespanEvaluator()));
+
+      InitializeOperators();
+      InitializeProblemInstance();
+    }
+
     [StorableConstructor]
     private JobShopSchedulingProblem(bool deserializing) : base(deserializing) { }
     private JobShopSchedulingProblem(JobShopSchedulingProblem original, Cloner cloner)
       : base(original, cloner) {
-      this.Jobs = cloner.Clone(original.Jobs);
-      this.Resources = cloner.Clone(original.Resources);
-      this.JobData = cloner.Clone(original.JobData);
-      this.SolutionEvaluator = cloner.Clone(original.SolutionEvaluator);
-      this.DueDates = cloner.Clone(original.DueDates);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JobShopSchedulingProblem(this, cloner);
-    }
-
-
-    #region Parameter Properties
-    public ValueParameter<ItemList<Job>> JobDataParameter {
-      get { return (ValueParameter<ItemList<Job>>)Parameters["JobData"]; }
-    }
-    public OptionalValueParameter<Schedule> BestKnownSolutionParameter {
-      get { return (OptionalValueParameter<Schedule>)Parameters["BestKnownSolution"]; }
-    }
-
-    public ValueParameter<IntValue> JobsParameter {
-      get { return (ValueParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public ValueParameter<IntValue> ResourcesParameter {
-      get { return (ValueParameter<IntValue>)Parameters["Resources"]; }
-    }
-    public ValueParameter<SchedulingEvaluator> SolutionEvaluatorParameter {
-      get { return (ValueParameter<SchedulingEvaluator>)Parameters["SolutionEvaluator"]; }
-    }
-    public ValueParameter<BoolValue> DueDatesParameter {
-      get { return (ValueParameter<BoolValue>)Parameters["DueDates"]; }
-    } 
-    #endregion
-
-    #region Properties
-    public ItemList<Job> JobData {
-      get { return JobDataParameter.Value; }
-      set { JobDataParameter.Value = value; }
-    }
-    public Schedule BestKnownSolution {
-      get { return BestKnownSolutionParameter.Value; }
-      set { BestKnownSolutionParameter.Value = value; }
-    }
-    public IntValue Jobs {
-      get { return JobsParameter.Value; }
-      set { JobsParameter.Value = value; }
-    }
-    public IntValue Resources {
-      get { return ResourcesParameter.Value; }
-      set { ResourcesParameter.Value = value; }
-    }
-    public SchedulingEvaluator SolutionEvaluator {
-      get { return SolutionEvaluatorParameter.Value; }
-      set { SolutionEvaluatorParameter.Value = value; }
-    }
-    public BoolValue DueDates {
-      get { return DueDatesParameter.Value; }
-      set { DueDatesParameter.Value = value; }
-    }
-    #endregion
-
-
-    public JobShopSchedulingProblem()
-      : base(new SchedulingEvaluationAlgorithm (), new JSMRandomCreator ()) {
-      Parameters.Add(new ValueParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<Job>()));
-      Parameters.Add(new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance."));
-
-      Parameters.Add(new ValueParameter<IntValue>("Jobs", "The number of jobs used in this JSSP instance.", new IntValue()));
-      Parameters.Add(new ValueParameter<IntValue>("Resources", "The number of resources used this JSSP instance.", new IntValue()));
-      Parameters.Add(new ValueParameter<BoolValue>("DueDates", "Determines whether the problem instance uses due dates or not.", new BoolValue()));
-      Parameters.Add(new ValueParameter<SchedulingEvaluator>("SolutionEvaluator", "The evaluator used to determine the quality of a solution.", new MakespanEvaluator()));
-
-      InitializeOperators();
-      InitializeProblemInstance();
     }
 
@@ -131,11 +116,15 @@
       InitializeOperators();
     }
+
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+    }
     #endregion
 
     #region Helpers
-    private void InitializeProblemInstance () {
-      Jobs = new IntValue (10); 
-      Resources = new IntValue (10); 
-      BestKnownQuality = new DoubleValue (930);
+    private void InitializeProblemInstance() {
+      Jobs = new IntValue(10);
+      Resources = new IntValue(10);
+      BestKnownQuality = new DoubleValue(930);
       JobData = new ItemList<Job>();
       List<string> data = new List<string>
@@ -167,13 +156,16 @@
       if (SolutionCreator.GetType().Equals(typeof(JSMRandomCreator))) {
         Operators.AddRange(ApplicationManager.Manager.GetInstances<IJSMOperator>());
-        ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<JSMEncoding>(new JSMDecoder());
+        JSMDecoder decoder = new JSMDecoder();
+        ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<JSMEncoding>(decoder);
       } else {
         if (SolutionCreator.GetType().Equals(typeof(PRVRandomCreator))) {
           Operators.AddRange(ApplicationManager.Manager.GetInstances<IPRVOperator>());
-          ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PRVEncoding>(new PRVDecoder());
+          PRVDecoder decoder = new PRVDecoder();
+          ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PRVEncoding>(decoder);
         } else {
           if (SolutionCreator.GetType().Equals(typeof(PWRRandomCreator))) {
             Operators.AddRange(ApplicationManager.Manager.GetInstances<IPWROperator>());
-            ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PWREncoding>(new PWRDecoder());
+            PWRDecoder decoder = new PWRDecoder();
+            ((SchedulingEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PWREncoding>(decoder);
           }
         }
@@ -197,11 +189,11 @@
     }
     private int[] GetIntArray(List<string> data) {
-      int[] arr = new int [data.Count];
-      for (int i = 0; i < data.Count; i++ ) {
+      int[] arr = new int[data.Count];
+      for (int i = 0; i < data.Count; i++) {
         arr[i] = Int32.Parse(data[i]);
       }
       return arr;
     }
-    private Job CreateJobFromData (List<string> data, int jobCount)   {
+    private Job CreateJobFromData(List<string> data, int jobCount) {
       DoubleValue dueDate = null;
       int dataCount = data.Count;
@@ -233,11 +225,11 @@
         if (data.Count > 0 && ((int)data[0][0] >= 48 && (int)data[0][0] <= 57)) {
           int jobCount = 0;
-          Jobs = new IntValue (Int32.Parse(data[0]));
-          Resources = new IntValue (Int32.Parse(data[1]));
+          Jobs = new IntValue(Int32.Parse(data[0]));
+          Resources = new IntValue(Int32.Parse(data[1]));
           //data[2] = bestKnownQuality (double)
           //data[3] = dueDates (0|1)
           DueDates.Value = false;
           if (data.Count > 2)
-            BestKnownQualityParameter.ActualValue = new DoubleValue(Double.Parse (data[2]));
+            BestKnownQualityParameter.ActualValue = new DoubleValue(Double.Parse(data[2]));
           if (data.Count > 3 && data[3] == "1")
             DueDates.Value = true;
@@ -265,5 +257,5 @@
       JSMEncoding solution = new JSMEncoding();
       while (!solutionFile.EndOfStream && !solutionFound) {
-        
+
         string line = solutionFile.ReadLine();
         List<string> data = SplitString(line);
@@ -274,5 +266,5 @@
           data = SplitString(line);
           while (data != null && data.Count > 0 && ((int)data[0][0] >= 48 && (int)data[0][0] <= 57)) {
-            Permutation p = new Permutation(PermutationTypes.Absolute, GetIntArray (data));
+            Permutation p = new Permutation(PermutationTypes.Absolute, GetIntArray(data));
             solution.JobSequenceMatrix.Add(p);
 
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Plugin.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Plugin.cs	(revision 6406)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Scheduling {
-  [Plugin("HeuristicLab.Problems.Scheduling", "3.3.3.6293")]
+  [Plugin("HeuristicLab.Problems.Scheduling", "3.3.3.6364")]
   [PluginFile("HeuristicLab.Problems.Scheduling-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsSchedulingPlugin : PluginBase {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/SchedulingProblem.cs	(revision 6406)
@@ -20,18 +20,14 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Optimization;
-using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
-using HeuristicLab.Encodings.SchedulingEncoding.Interfaces;
 
 namespace HeuristicLab.Problems.Scheduling {
-  [Item("Scheduling Problem", "Abstract class that represents a Scheduling Problem")]
+  [Item("SchedulingProblem", "Abstract class that represents a Scheduling Problem")]
   [StorableClass]
-  public abstract class SchedulingProblem : SingleObjectiveHeuristicOptimizationProblem<ISchedulingEvaluationAlgorithm, ISchedulingCreator> {
+  public abstract class SchedulingProblem : SingleObjectiveHeuristicOptimizationProblem<IScheduleEvaluationAlgorithm, IScheduleCreator> {
     [StorableConstructor]
     protected SchedulingProblem(bool deserializing) : base(deserializing) { }
@@ -40,5 +36,5 @@
     }
 
-    protected SchedulingProblem (ISchedulingEvaluationAlgorithm se, ISchedulingCreator sc) : base (se, sc) {}
+    protected SchedulingProblem(IScheduleEvaluationAlgorithm se, IScheduleCreator sc) : base(se, sc) { }
 
   }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Task.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Task.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Task.cs	(revision 6406)
@@ -20,12 +20,9 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Problems.Scheduling {
@@ -33,4 +30,15 @@
   [StorableClass]
   public class Task : Item {
+    [Storable]
+    public IntValue TaskNr { get; set; }
+    [Storable]
+    public IntValue ResourceNr { get; set; }
+    [Storable]
+    public IntValue JobNr { get; set; }
+    [Storable]
+    public DoubleValue Duration { get; set; }
+    [Storable]
+    public BoolValue IsScheduled { get; set; }
+
     [StorableConstructor]
     protected Task(bool deserializing) : base(deserializing) { }
@@ -48,16 +56,10 @@
 
 
-    public IntValue TaskNr { get; set; }
-    public IntValue ResourceNr { get; set; }
-    public IntValue JobNr { get; set; }
-    public DoubleValue Duration { get; set; }
-    public BoolValue IsScheduled { get; set; }
-
-
-    public Task (int taskNr, int resNr, int jobNr, double duration) : base () {
-      Duration = new DoubleValue (duration);
-      ResourceNr = new IntValue (resNr);
-      JobNr = new IntValue (jobNr);
-      TaskNr = new IntValue (taskNr);
+    public Task(int taskNr, int resNr, int jobNr, double duration)
+      : base() {
+      Duration = new DoubleValue(duration);
+      ResourceNr = new IntValue(resNr);
+      JobNr = new IntValue(jobNr);
+      TaskNr = new IntValue(taskNr);
       IsScheduled = new BoolValue(false);
     }
Index: /branches/Scheduling/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj
===================================================================
--- /branches/Scheduling/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6405)
+++ /branches/Scheduling/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6406)
@@ -252,12 +252,4 @@
       <Name>HeuristicLab.Encodings.RealVectorEncoding-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SchedulingEncoding.Views\3.3\HeuristicLab.Encodings.SchedulingEncoding.Views-3.3.csproj">
-      <Project>{0C378762-D5DB-488A-8931-2BA42B1B7CBF}</Project>
-      <Name>HeuristicLab.Encodings.SchedulingEncoding.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SchedulingEncoding\3.3\HeuristicLab.Encodings.SchedulingEncoding-3.3.csproj">
-      <Project>{17F3EF80-B2C3-4B8D-A4D5-BE9CE3BA2606}</Project>
-      <Name>HeuristicLab.Encodings.SchedulingEncoding-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views\3.3\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.3.csproj">
       <Project>{6F42C5F8-16CD-43EE-8208-FD4573A69D85}</Project>
